#coding:latin-1
"""
extrait les sites de nombreux blogs sur internet et construit un graphe des liens
"""

import re, os, urllib2, codecs, copy
import find_blog_examples

blog_addition = [   "http://www.audreycuisine.fr/",
                    "http://www.lacuisinehelene.com/",
                    "http://biscottine.over-blog.fr/",
                    "http://blog-cuisine.marmiton.org/",
                    "http://cuisinedumonde.tumblr.com/",
                    "http://www.cuisinecapers.com/",
                    "http://chocolateandzucchini.com/",
                    "http://www.cleacuisine.fr/",
                    "http://www.mercotte.fr/",
                ]

class Blog :
    def __init__ (self, url, tempFolder) :
        self.url = url
        self.tempFolder = tempFolder

    def __str__ (self) :
        return self.url

    @staticmethod
    def extract_blogs_from_xml_file(filename, tempFolder) :
        f = open (filename, "r")
        text = f.read()
        f.close()

        exp = re.compile ("htmlUrl=\"(http://[-a-zA-Z0-9/.?]+)\"")
        all = exp.findall(text)
        dic = { }
        for a in all : dic[a] = 0
        all = dic.keys() + blog_addition
        return [ Blog(_.strip("?/")+"/", tempFolder) for _ in all ]

    def get_file (self) :
        return self.url[7:].replace (".","_").replace ("/","_").replace("?","_")+".html"

    def __cmp__ (self, o) :
        return cmp(self.url,o)

    def content (self, log = False) :
        folder = self.tempFolder
        if not os.path.exists (folder) : os.mkdir (folder)
        filename = os.path.join(folder, self.get_file())
        if os.path.exists (filename) :
            if log : print "reading from file ", str(self)
            try :
                f = open(filename,"r")
                text = f.read()
                f.close ()
            except IOError, e:
                # permission denied because probably spam site
                text = ""
            return text
        else :
            if log : print "reading from url ", str(self)
            try :
                u = urllib2.urlopen(self.url)
                text = u.read()
                u.close ()
                f = open(filename,"w")
                f.write(text)
                return text
            except Exception ,e :
                if log : print "error ", self
                return ""

    generator = [   """<meta name="generator" content="WordPress""",
                    """<meta content='blogger' name='generator'/>""",
                    """href="http://fdata.over-blog.net""",
                    ]
    def is_blog (self, message = False) :

        if self.url.startswith ("http://www.") :
            if "blog" in self.url or "rss.xml" in self.url : return True
            else :
                text = self.content()
                if len(text) == 0 :
                    if message : return "no content --> error"
                    return False
                pos1 = text.find("application/rss+xml")
                pos2 = text.find("application/atom+xml")
                if pos1 == -1 and pos2 == -1:
                    if message : return "no application/rss+xml (1) " + " -- " + self.get_file () + " -- " + str (os.path.exists (self.get_file()))
                    return False
                else :
                    return True
        else :
            text = self.content()
            if len(text) == 0 :
                if message : return "no content --> error"
                return False
            pos1 = text.find("application/rss+xml")
            pos2 = text.find("application/atom+xml")
            if message :
                if pos1 == -1 and pos2 == -1: return "no application/rss+xml (2)"  + " -- " +self.get_file () + " -- " + str (os.path.exists (self.get_file()))
                else : return True
            else :
                if pos1 == -1 and pos2 == -1: return False
                else : return True

    @staticmethod
    def get_root_static (url) :
        root = url[7:].split("/")[0]
        if len(root) < 5 or "." not in root :
            return None
        return root

    def get_root (self) :
        return Blog.get_root_static(self.url)

    regTitle = re.compile ("<title>(.*)</title>")
    def get_title (self) :
        titles = Blog.regTitle.findall (self.content())
        if len(titles) > 0 : return titles[0]
        else : return ""

    expLink = re.compile ("=\"(http://[-a-zA-Z0-9/.?]+)\"")
    extLink = {"ico":None, "png":None, "jpg":None, "gif":None }
    def get_filter_link(self) :
        root = self.get_root()
        all = Blog.expLink.findall(self.content())
        res = []
        for a in all :
            r1 = Blog.get_root_static(a)
            if r1 == None : continue
            if r1 == root : continue
            ext = a[-3:]
            if ext.lower() not in Blog.extLink:
                res.append("http://" + r1.strip ("?/") + "/")  # ici on prend la racine, pas besoin de plus, sinon on rcupre pas mal d'articles
        res.sort ()

        final = []
        for r in res :
            if len(final) == 0 or not r.startswith(final[-1]) :
                if len(final) > 0 :
                    r1 = Blog.get_root_static(final[-1])
                    r2 = Blog.get_root_static(r)
                    if r1 != r2 :
                        final.append(r)
                else :
                    final.append(r)
        return final

    @staticmethod
    def graph_links (blogs, outEdge, outTitle, nbMax, log = True) :
        blogsInit   = copy.copy(blogs)
        blogs       = { }
        for b in blogsInit :
            blogs [b.url] = b
            b.linkTo = 0

        unique      = { }
        fout        = open(outEdge,"w")
        nbedge      = 0
        inb         = 0
        foutitle    = open(outTitle,"w")

        while len(blogs)>0 and (len(unique) < nbMax or nbedge < nbMax*5) :

            # on prend celui qui est le plus point
            blog = None
            for k, bl in blogs.iteritems () :
                if blog == None or bl.linkTo > blog.linkTo :
                    blog = bl
            del blogs[blog.url]

            if blog.url not in unique :
                unique[blog.url] = blog
                foutitle.write("%s\t%s\n"%( blog.url,blog.get_title()))
                if log :
                    text = blog.content()
                    if len (text) == 0 :
                        print "   no content --> error"

            if blog.is_blog () :
                if log : print "loop", inb, " nb unique ", len(unique), " left ", len (blogs), " edges ", nbedge, " process (linkTo ", blog.linkTo, ":", blog
                links = blog.get_filter_link()
                edge = [ Blog (l, blog.tempFolder) for l in links ]
                for l in edge :
                    if l.is_blog () :
                        if l.url not in unique :
                            if l.url in blogs :
                                blogs [l.url].linkTo += 1
                            else :
                                blogs [l.url] = l
                                l.linkTo = 1
                        else :
                            unique [l.url].linkTo += 1

                        fout.write ("%s\t%s\n"% (str(blog), str(l)))
                        nbedge+=1

                fout.flush()
                foutitle.flush()
            inb += 1

        if log : print "writing titles ", len (unique)

        for k,blog in blogs.iteritems () :
            if log : print "adding title ", k
            foutitle.write("%s\t%s\n"%( blog.url,blog.get_title()))

        fout.close ()
        foutitle.close()
        if log : print "end"


if __name__ == "__main__" :

    #for url in find_blog_examples.listblog :
    #    print Blog.get_root_static(url), " --- ", url

    seeds = Blog.extract_blogs_from_xml_file("blogs.xml", "tempBlog")
    seeds.append (Blog("http://www.lemonde.fr/", "tempBlog"))
    seeds.sort()
    print "nb blogs ", len(seeds)
    for b in seeds :
        r = b.is_blog()
        if not r :
            print r, b.url, b.is_blog(True)

    Blog.graph_links(seeds, "blog_edges.txt", "blog_title.txt", 10000)
